// mUtil.cpp

#include <cstdarg>
#include <cstring>
#include <time.h>
#include "mUtil.h"

using namespace std;

// Explodes a string into a vector
void explode(vector<string> &res, string &haystack, const char* needle) {
	res.clear();
	size_t i = 0, last = 0, needle_len = strlen(needle);
	for(;;) {
		i = haystack.find(needle, last);
		if (i == haystack.npos) {
			res.push_back(haystack.substr(last));
			break;
		}
		res.push_back(haystack.substr(last, i-last));
		last = i+needle_len;
	}
}

// Printf-style string formatting
string format_arg_list(const char *fmt, va_list args) {
    if (!fmt) return "";
    int   result = -1, length = 256;
    char *buffer = 0;

	while (result == -1) {
        if (buffer) delete [] buffer;
        buffer = new char [length + 1];
        memset(buffer, 0, length + 1);
		//result = vsprintf_s(buffer, length, fmt, args);
		result = vsnprintf(buffer, length, fmt, args);
        length *= 2;
    }

    string s(buffer);
    delete [] buffer;
    return s;
}

// Printf-style string formatting
string format(const char *fmt, ...) {
    va_list args;
    va_start(args, fmt);
    string s = format_arg_list(fmt, args);
    va_end(args);
    return s;
}

// Performs a find/replace operation over str.
void replace(string& str, const char* find, const char* replace) {
	size_t pos = 0;
	int find_len = strlen(find), replace_len = strlen(replace);
	while ( (pos = str.find(find, pos)) != string::npos) {
		str.replace(pos, find_len, replace);
		pos += replace_len;
	}
}

// Returns a formatted timestamp string
string timestamp() {
	time_t t = time(0);
	struct tm *tm_struct = localtime(&t);
	return format("[%02d:%02d]", tm_struct->tm_hour, tm_struct->tm_min);
}